///////////////////////////////////////////////////////////////////
// SpatialNavigation.cpp
// \irǗNX
///////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "SpatialNavigation.h"
#include "patriotGlobalDom.h"
#include "patriotGlobal2.h"


///////////////////////////////////////////////////////////////////
/// CSpatialNavigation
///////////////////////////////////////////////////////////////////

/// RXgN^
CSpatialNavigation::CSpatialNavigation()
	: arrElementX()
	, arrElementY()
	, arrElementW()
	, arrElementH()
	, m_strCachedURL()
	, m_nCachedLinkCount(0)
	, m_nTimeLastExecCmd(0)
{
}

/// 
void CSpatialNavigation::Clear()
{
	// ÑLbV폜
	if (arrElementX.GetSize() != 0) {
		arrElementX.RemoveAll();
		arrElementW.RemoveAll();
		arrElementY.RemoveAll();
		arrElementH.RemoveAll();
	}
}

/// ׂ
double CSpatialNavigation::pow(double value, long count)
{
	double result = value;
	for (long i = 1; i < count; i++) {
		result *= value;
	}
	return result;
}


/// hLg̑SGg̍W擾
BOOL CSpatialNavigation::CalcElementsLayout(LPDISPATCH pDisp, RECT& rectBody)
{
	if (pDisp == NULL) {
		return FALSE;
	}
	CComBSTR 					bstrURL;
	CComQIPtr<IHTMLDocument2>	spHtmlDocument = pDisp;

	// XVĂȂ(URLOƓ)
	spHtmlDocument->get_URL( &bstrURL );
	CComQIPtr<IHTMLElementCollection> spElements;
	spHtmlDocument->get_links(&spElements);

	LONG nLength = 0;
	spElements->get_length( &nLength );
	if (arrElementX.GetSize() !=0 && CString/*+++*/(bstrURL) == m_strCachedURL
			&& m_nCachedLinkCount == nLength) {
		return TRUE;
	}

	// XVĂ
	m_nCachedLinkCount = nLength;
	m_strCachedURL	   = bstrURL;

	arrElementX.SetSize( nLength );
	arrElementY.SetSize( nLength );
	arrElementW.SetSize( nLength );
	arrElementH.SetSize( nLength );

	CRect rect;
	try{
		VARIANT 	varIndex = {0};
		VARIANT 	varNULL  = {0};
		// [v
		for ( int i = 0; i < nLength; i++ ) {
			varIndex.vt   = VT_UINT;
			varIndex.lVal = i;

			LPDISPATCH 	pLinkElmDisp;
			spElements->item( varIndex, varNULL, &pLinkElmDisp );
			if ( pLinkElmDisp == NULL ) {
				continue;
			}

			rect = GetElementPosition(pLinkElmDisp, rectBody);

			arrElementX.SetAt( i, rect.left 	);
			arrElementW.SetAt( i, rect.Width()	);
			arrElementY.SetAt( i, rect.top		);
			arrElementH.SetAt( i, rect.Height() );

			pLinkElmDisp->Release();
		}
	}
	catch(...){
		AfxMessageBox( _T("Err:GetElementsPosInDoc") );
		return FALSE;
	}
	return TRUE;
}

/// Gg̍W擾
RECT CSpatialNavigation::GetElementPosition(LPDISPATCH pDisp, RECT& rectBody)
{
	RECT rect = {0, 0, 0, 0};
	if (pDisp == NULL) {
		return rect;
	}
	try{
		CComQIPtr<IHTMLElement2>	spElement = pDisp;
		CComQIPtr<IHTMLRect> 		spRect;
		spElement->getBoundingClientRect(&spRect);

		spRect->get_left(&rect.left);
		spRect->get_right(&rect.right);
		spRect->get_top(&rect.top);
		spRect->get_bottom(&rect.bottom);

		rect.left 	+= rectBody.left - 2;
		rect.right 	+= rectBody.left - 2;
		rect.top 	+= rectBody.top  - 2;
		rect.bottom += rectBody.top  - 2;
		/*
		// N̒Sʒu擾
		long width ;
		long height;
		pElement->get_offsetWidth( &width );
		pElement->get_offsetHeight( &height );

		while ( pElement ) { // BODY܂ŃItZbg𑫂
			long left;
			long top ;
			pElement->get_offsetLeft( &left );
			pElement->get_offsetTop( &top );

			rect.left += left;
			rect.top  += top;

			CComPtr<IHTMLElement> pElementOld = pElement;
			pElement.Release();
			pElementOld->get_offsetParent( &pElement );
		}

		rect.right	= rect.left + width;
		rect.bottom = rect.top	+ height;
		*/
	}
	catch(...){
		AfxMessageBox( _T("Err:GetElementPos") );
		return rect;
	}
	return rect;
}

/// XN[WȂǂ擾
RECT CSpatialNavigation::GetBodyRect(LPDISPATCH pDisp)
{
	RECT rect = {0, 0, 0, 0};
	CComQIPtr<IHTMLElement2> pBodyElement2 = pDisp;
	if (pBodyElement2 == NULL) {
		return rect;
	}

	pBodyElement2->get_scrollTop(&rect.top);
	pBodyElement2->get_scrollLeft(&rect.left);

	long nWidth = 0, nHeight = 0;
	pBodyElement2->get_clientWidth(&nWidth);
	pBodyElement2->get_clientHeight(&nHeight);

	rect.bottom = rect.top	+ nHeight;
	rect.right	= rect.left + nWidth;


	const int MIN_SCREEN_HEIGHT = 640;
	if (rect.top == 0 && rect.bottom - rect.top > MIN_SCREEN_HEIGHT) {
		// CSS1Compat΍
		CComQIPtr<IHTMLElement> spBodyElement = pDisp;
		CComPtr<IHTMLElement> spDocumentElement;
		spBodyElement->get_parentElement(&spDocumentElement);
		CComQIPtr<IHTMLElement2> spDocumentElement2 = spDocumentElement;

		if (spDocumentElement2) {
			RECT rect2 = {0, 0, 0, 0};
			spDocumentElement2->get_scrollTop(&rect2.top);
			spDocumentElement2->get_scrollLeft(&rect2.left);

			long nWidth2 = 0, nHeight2 = 0;
			spDocumentElement2->get_clientWidth(&nWidth2);
			spDocumentElement2->get_clientHeight(&nHeight2);

			rect2.bottom = rect2.top + nHeight2;
			rect2.right = rect2.left + nWidth2;

			if (rect2.top > rect.top || (rect2.bottom - rect2.top < rect.bottom - rect.top && rect2.bottom > 0)) {
				rect = rect2;
			}
		}
	}
	return rect;
}

/// ԋ߂NɃtH[JX
BOOL CSpatialNavigation::SetFocus(LPDISPATCH pDisp, int nCommand)
{
	try{
		// hLg̍W擾
		CComQIPtr<IHTMLDocument2> pHtmlDocument = pDisp;
		if (pHtmlDocument == NULL) {
			return FALSE;
		}

		// ݂̃XN[W擾
		CComPtr<IHTMLElement>	pBodyElement;
		pHtmlDocument->get_body(&pBodyElement);
		CRect	rectBody = GetBodyRect(pBodyElement);
		if (!CalcElementsLayout(pHtmlDocument, rectBody)) {
			ASSERT(1);
			return FALSE;
		}

		// ANeBuȗvf̍W擾
		LPDISPATCH pDisp2 = GetSelectedElement2(pHtmlDocument);
		if (pDisp2 == NULL) {
			ASSERT(1);
			return FALSE;
		}
		CRect	rect = GetElementPosition(pDisp2, rectBody);
		if (rectBody.top == 0) {
			rect.bottom = rect.top + 2;
		}
		CString strActiveElementTagName = GetElementTagName(pDisp2);
		if (strActiveElementTagName == _T("HTML") || strActiveElementTagName == _T("BODY")) {
			// tH[JXȂ̂ō[Ɉԋ߂ACe擾
			const RECT RECT_LEFT_TOP_BOX = {0, 0, 2, 2};
			rect = RECT_LEFT_TOP_BOX;
		} else if (strActiveElementTagName == _T("FRAME") || strActiveElementTagName == _T("IFRAME")) {
			// todo: t[ɃtH[JX
			TRACE(_T("t[ɃtH[JX"));
			/*
			CComQIPtr<IHTMLElement> spElement = pDisp2;
			CComBSTR bstrHtml;
			spElement->g
			spElement->get_outerHTML(&bstrHtml);
			AfxMessageBox(CString(bstrHtml));
			*/
		}
		if (rect.bottom + 100 < rectBody.top) {
			// tH[JX̂Ggʂ
			rect.top	= rectBody.top;
			rect.bottom = rectBody.top + 2;
			rect.left	= 0;
			rect.right	= 2;
		} else if ((rect.top > rectBody.bottom + 100 && rectBody.Height() > 100)
			|| (rect.Width() >= rectBody.Width() && rect.Height() >= rectBody.Height())) {
			// tH[JX̂Ggʂ艺
			// or ʂɎ܂肫ȂvfɃtH[JX
			//	  (̏ꍇAHTMLhLg)
			if (nCommand == SPATIAL_UP) { // {^
				rect.top	= rectBody.bottom - 2;
				rect.bottom = rect.top + 2;
				rect.left	= 0;
				rect.right	= 2;
			} else {
				rect.top	= rectBody.top;
				rect.bottom = rect.top + 2;
				rect.left	= rectBody.left;
				rect.right	= rectBody.right;
			}
		}

		/*
		CString str;
		str.Format(_T("(%d,%d)-(%d,%d)"),rect.left,rect.top,rect.right,rect.bottom);
		AfxGetMainWnd()->SetWindowText(str);
		*/

		int 	iIndex		 = -1;
		int 	count		 = int( arrElementX.GetSize() );
		double	iDistanceMin = 99999999999999, iDistance = 999999999999999;

		// ŒZǂ
		int 	activeCenterX = (rect.left + rect.right) / 2;
		int 	activeCenterY = (rect.top + rect.bottom) / 2;
		for (int j = 0; j < count; j++) {
			int jX = (int)arrElementX.GetAt(j);
			int jY = (int)arrElementY.GetAt(j);
			int jW = (int)arrElementW.GetAt(j);
			int jH = (int)arrElementH.GetAt(j);
			// EE
			if ((nCommand == SPATIAL_LEFT && jX - 2 < rect.left)
					|| (nCommand == SPATIAL_RIGHT && jX + 2 > rect.right)) {
				int jCenterX = jX + jW / 2;
				int jCenterY = jY + jH / 2;
				if ((abs(jCenterX - activeCenterX) < 150 &&  abs(jCenterX - activeCenterX) > abs(jCenterY - activeCenterY) * 2)
						|| (abs(jCenterX - activeCenterX) > abs(jCenterY - activeCenterY) * 3)) {
					double iDistanceX	= (nCommand == 0) ? rect.left - jX : jX - rect.right;
					iDistance 			= pow( iDistanceX, 2);

					// `Ԃ̋擾
					if (rect.top > jY + jH) {
						iDistance += pow(rect.top - jY + jH, 2) * 2;
					} else if (rect.bottom < jY) {
						iDistance += pow(rect.bottom - jY, 2) * 2;
					}
				}
			}
			// E
			else if ((nCommand == SPATIAL_UP && jY + jH - 2 < rect.top)
				||	(nCommand == SPATIAL_DOWN && jY + 2 > rect.bottom)) {
				double iDistanceY = (nCommand == SPATIAL_UP) ? rect.top - jY - jH : jY - rect.bottom;
				iDistance 		  = pow(iDistanceY, 2);

				if (rect.left > jX + jW) {
					iDistance += pow( jX + jW - rect.left, 2 ) * 3;
				} else if (rect.right < jX) {
					iDistance += pow( jX - rect.right, 2 ) * 3;
				}
			}

			if (iDistance <= 64) {
				iIndex = j;
				break;
			}

			if (iDistance < iDistanceMin) {
				iDistanceMin = iDistance;
				iIndex 		 = j;
				iDistance 	 = 999999999999999;
			}
		}
		if (iIndex == -1) {
			return FALSE;
		}
		// NɃtH[JX𓖂Ă
		CComPtr<IHTMLElementCollection> pElements;
		::GetTickCount();
		pHtmlDocument->get_links(&pElements);
		if ( pElements == NULL ) {
			return FALSE;
		}

		VARIANT  varIndex = {0};
		varIndex.vt 	= VT_UINT;
		varIndex.lVal	= iIndex;
		VARIANT varNULL = {0};

		CComPtr<IDispatch> spDisp;
		pElements->item( varIndex, varNULL, &spDisp );
		if (spDisp == NULL) {
			return FALSE;
		}

		CComQIPtr<IHTMLAnchorElement> pAnchorElement = spDisp;
		if (pAnchorElement == NULL) {
			return FALSE;
		}

		CComQIPtr<IHTMLElement> 	pAnchorElement2 = pAnchorElement;
		CComQIPtr<IHTMLBodyElement> pBodyElement3 	= pBodyElement;

		CComQIPtr<IHTMLTxtRange> pTextRange;
		pBodyElement3->createTextRange( &pTextRange );
		// eLXgI
		if ( pTextRange != NULL ) {
			pTextRange->moveToElementText( pAnchorElement2 );
			pTextRange->select();
		}

		// tH[JXݒ
		pAnchorElement->focus();
		/*
		// ---------------------------------
		// N̈ʒu
		CView* pView = static_cast<CMDIFrameWnd*>(AfxGetMainWnd())->MDIGetActive()->GetActiveView();

		for (iIndex = 0; iIndex < count; iIndex++) {
			long absX = arrElementX.GetAt(iIndex) - rectBody.left;
			long absY = arrElementY.GetAt(iIndex) - rectBody.top;
			RECT rectElement = {absX, absY, absX + arrElementW.GetAt(iIndex), absY + arrElementH.GetAt(iIndex)};

			DoEvents();

			CClientDC dc( pView );

			COLORREF color = RGB(255, 0, 255);
			CPen pen(PS_SOLID, 1, color);
			CPen* oldPen = dc.SelectObject(&pen);
			CBrush brush;
			brush.CreateSolidBrush(color);
			CBrush* oldBrush = dc.SelectObject(&brush);
			dc.FrameRect(&rectElement, &brush);
			dc.SelectObject(oldPen);
			dc.SelectObject(oldBrush);
		}

		//CString strStatus;
		//strStatus.Format( _T("NextLink:%d"), iIndex);
		//((CMDIFrameWnd*)AfxGetMainWnd())->SetWindowText(strStatus);
		// ---------------------------------
		*/
		pDisp->Release();
		DoEvents();
		return TRUE;
	} catch(...){
		return FALSE;
	}
}

